.\" -*-nroff-*-
.\"=====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "0.02",
.\"     date            = "21 May 2001",
.\"     time            = "14:14:27 MDT",
.\"     filename        = "texpty.man",
.\"     address         = "Center for Scientific Computing
.\"                        Department of Mathematics
.\"                        University of Utah
.\"                        Salt Lake City, UT 84112
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 581 4148",
.\"     checksum        = "61154 1430 5744 46508",
.\"     email           = "beebe@math.utah.edu, beebe@acm.org,
.\"                        beebe@computer.org, beebe@ieee.org,
.\"                        (Internet)",
.\"     email           = "beebe@math.utah.edu (Internet)",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "AmSTeX, AmSLaTeX, ETeX, LAmSTeX, LaTeX,
.\"                        SliTeX, TeX, prettyprinter",
.\"     supported       = "yes",
.\"     docstring       = "This file contains the UNIX manual pages
.\"                        for the texpretty utility, a program for
.\"                        prettyprinting TeX (and AmSTeX, AmSLaTeX,
.\"                        ETeX, LAmSTeX, LaTeX, SliTeX, ...) files.
.\"
.\"                        The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\"=====================================================================
.TH TEXPRETTY 1 "21 May 2001" "Version 0.02"
.\"=====================================================================
.\"
.if t .ds Am A\\h'-0.1667m'\\v'0.20v'M\\v'-0.20v'\\h'-0.125m'S
.if n .ds Am AmS
.\"
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Te TeX
.\"
.if t .ds Ax \*(Am\*(Te
.if n .ds Ax AmSTeX
.\"
.if t .ds Ex E\*(Te
.if n .ds Ex ETeX
.\"
.if t .ds La L\\h'-0.24m'\\v'-0.15v'\\s-2A\\s+2\\h'-0.15m'\\v'0.15v'\*(Te
.if n .ds La LaTeX
.\"
.if t .ds Al \*(Am\*(La
.if n .ds Al AmSLaTeX
.\"
.if t .ds Lm L\*(Ax
.if n .ds Lm LAmSTeX
.\"
.if t .ds Sx Sli\*(Te
.if n .ds Sx SliTeX
.\"
.if t .ds Li \*(La\&info
.if n .ds Li LaTeXinfo
.\"
.if t .ds Ti \*(Te\&info
.if n .ds Ti TeXinfo
.\"
.\"=====================================================================
.SH NAME
texpretty \- prettyprint TeX (and AmSLaTeX, AmSTeX, ETeX, LAmSTeX, LaTeX, LaTeXinfo, SliTeX, TeXinfo, ...) files
.\"=====================================================================
.SH SYNOPSIS
.B texpretty
[
.B \-?
]
[
.B \-@
]
[
.B \-a
]
[
.B \-c
]
[
.B \-d
]
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.BI \-e " modename"
]
[
.BI \-f " filename"
]
[
.B \-h
]
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.BI \-i " nnn"
]
[
.BI \-l " filename"
]
.if t .ti +\w'\fBtexpretty\fP\ 'u
[
.BI \-m " nnn"
]
[
.B \-n
]
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.BI \-o " filename"
]
[
.B \-q
]
[
.BI \-s " filename"
]
[
.B \-t
]
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.B \-v
]
[
.BI \-w " nnn"
]
.nf
.if n .ti +\w'\fBtexpretty\fP\ 'u
.if t .ti +\w'\fBtexpretty\fP\ 'u
< infile > outfile
.if n .ti +\w'\fBtexpretty\fP\ 'u
.if t .ti +\w'\fBtexpretty\fP\ 'u
or
.if n .ti +\w'\fBtexpretty\fP\ 'u
.if t .ti +\w'\fBtexpretty\fP\ 'u
file(s) > outfile
.fi
.PP
.B texpretty
[
.B \-\-?
]
[
.B \-\-texinfo
]
[
.B \-\-author
]
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.B \-\-copyright
]
[
.B \-\-displaymath-all
]
.if t .ti +\w'\fBtexpretty\fP\ 'u
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.BI \-\-emacs-mode " modename"
]
[
.BI \-\-filename " filename"
]
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.B \-\-help
]
[
.BI \-\-indent " nnn"
]
.if t .ti +\w'\fBtexpretty\fP\ 'u
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.BI \-\-logfile " filename"
]
[
.BI \-\-math-conversions " nnn"
]
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.B \-\-no-comment-banner
]
.if t .ti +\w'\fBtexpretty\fP\ 'u
[
.BI \-\-outfile " filename"
]
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.B \-\-quick
]
[
.BI \-\-stylefile " filename"
]
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.B \-\-tabular-as-verbatim
]
.if t .ti +\w'\fBtexpretty\fP\ 'u
[
.B \-\-version
]
.if n .ti +\w'\fBtexpretty\fP\ 'u
[
.BI \-\-width " nnn"
]
.nf
.if n .ti +\w'\fBtexpretty\fP\ 'u
.if t .ti +\w'\fBtexpretty\fP\ 'u
< infile > outfile
.if n .ti +\w'\fBtexpretty\fP\ 'u
.if t .ti +\w'\fBtexpretty\fP\ 'u
or
.if n .ti +\w'\fBtexpretty\fP\ 'u
.if t .ti +\w'\fBtexpretty\fP\ 'u
file(s) > outfile
.fi
.\"=====================================================================
.SH DESCRIPTION
.PP
.B texpretty
filters its \*(Te\& input from
.IR stdin ,
or from one or more files named on the command line, and prettyprints
it to
.IR stdout .
Most formatting systems based on \*(Te\&, including \*(Ax\&,
\*(Al\&, \*(Ex\& (K. Berry's Extended plain \*(Te\&), \*(Lm\&,
\*(La\&, and \*(Sx\&, are handled reasonably well.
.B texpretty
also includes support for the Free Software Foundation's GNU Project
\*(Ti\&, whose markup syntax resembles that of
.BR scribe (1)
rather than that of \*(Te\&.
.PP
\*(Li\& is similar enough to \*(La\& that it can be handled by
.BR texpretty ,
.I provided
a suitable supplementary style file is supplied; an example is given
in the
.B "STYLE FILES"
section below.
.PP
Although prettyprinters of necessity impose a certain style that may
not be universally agreed upon, they have nevertheless proven useful
for many programming languages for heuristic syntax checking, and for
generating a consistent appearance in files that may have been
prepared by many authors (human, or computer programs), or even by a
single author with lax file preparation discipline.
.PP
Because of their low-level markup, plain \*(Te\& and \*(Ax\& files
offer fewer opportunities for useful prettyprinting than do \*(La\&,
\*(Lm\&, and \*(Sx\&.  Nevertheless, the heuristic error
checking provided by
.B texpretty
may still be useful for catching brace, dollar, and environment
balance errors.
.PP
\*(La\& users are advised to make regular use of
.BR lacheck (1),
which warns about many other kinds of likely errors that \*(La\&
itself cannot detect.
.B texpretty
will automatically repair some of these types of errors.
.PP
.B texpretty
may be less useful for files consisting only of macro definitions
(e.g.,
.IR plain.tex ,
or \*(La\& style files), because
.RS
.TP \w'\(bu'u+1n
\(bu
they may already have stylized formatting,
.TP
\(bu
macro definitions might include unclosed environments, and
.TP
\(bu
there is usually little structure in such files to be exposed by
prettyprinting.
.RE
.PP
Because \*(Te\& commands can be arcane, and do unexpected things,
users of
.B texpretty
are urged to check the output carefully, and not replace input files
with prettyprinted output files until the latter have been typeset and
verified.
.PP
.B texpretty
does not examine included files that would be read by \*(Te\& during
processing of commands like \fC\ebibliography\fP, \fC\einclude\fP,
\fC\einput\fP, \fC\elistoffigures\fP, \fC\elistoftables\fP,
\fC\eprintindex\fP, \fC\etableofcontents\fP, \&.\|.\|.  You must
provide these files to
.B texpretty
explicitly if you want them to be prettyprinted.
.\"=====================================================================
.SH OPTIONS
The following command-line options are supported, and they affect all
remaining filenames on the command line.  Option values are always
provided as separate arguments following the option name.
.PP
Letter case in option names is
.I not
significant, although it may be in option values.
.PP
GNU- and POSIX-style long options of the form
.B \-\|\-name
are also recognized: they begin with one or two option prefix
characters.  Long option names may be abbreviated to any unique
leading prefix, unless a shorter prefix is documented.
.PP
Any argument that begins with a hyphen is expected to be an option,
and will raise an error if it is not recognized.  If a filename begins
with a hyphen, you therefore need to disguise it by supplying a
leading directory path.  For example,
.IR ./\-foo
represents the file named
.I \-foo
in the current directory in UNIX.
.PP
Unrecognized arguments, or arguments lacking an expected value string,
result in an error message on
.IR stderr ,
and immediate termination with a failure status code.
.\"---------------------------------------------------------------------
.TP \w'\fB\-\-emacs-mode\fP\ \fImode-name\fP'u+1n
.B \-@
.TP
.B \-\-texinfo
Set \*(Ti\& mode, so that at-sign is the escape character instead of
backslash.  Although backslash-prefixed control sequences continue to
be recognized, dollar signs are ordinary characters, so special
treatment of \*(Te\& mathematics mode is disabled.  In addition, any
settings from
.BR \-d " (display math formatting),"
.BR \-e " (Emacs mode),"
.BR \-i " (indentation),"
and
.BR \-m " (mathematics conversion)"
options are ignored, and the indentation level spacing is set to zero,
because leading spaces can be significant in the info-mode text
produced from \*(Ti\& files.
.IP
Because \*(Ti\& is a continually evolving language, all \*(Ti\&
commands that do not require special handling are enumerated in
.BR texpretty ;
any others that it finds will raise a warning message.  Such new
commands can probably be handled without modifying
.BR texpretty ;
see the
.B "STYLE FILES"
section below.
.\"---------------------------------------------------------------------
.TP
.B \-a
.TP
.B \-\-author
Show author information on
.IR stderr ,
and terminate immediately with a success status code.
.\"---------------------------------------------------------------------
.TP
.B \-c
.TP
.B \-\-copyright
Show copyright information on
.IR stderr ,
and terminate immediately with a success status code.
.\"---------------------------------------------------------------------
.TP
.B \-d
.TP
.B \-\-displaymath-all
Use display-mathematics style formatting for inline mathematics.
This helps to set off mathematics text, and makes it easier to inspect
it for correctness, However, in documents that make heavy use of
inline mathematics, it may detract from readability of the
non-mathematics material.
.\"---------------------------------------------------------------------
.TP
.BI \-e " modename"
.TP
.BI \-\-emacs-mode " modename"
Supply an Emacs mode name for the leading comment banner (default: TeX).
.\"---------------------------------------------------------------------
.TP
.BI \-f " filename"
.TP
.BI \-\-filename " filename"
Supply an alternate input filename for use in the output comment
banner.  This overrides the actual filename(s), and provides a way to
name the output, even when no named input file is available, because
standard input is redirected, or comes from a pipe.
.\"---------------------------------------------------------------------
.TP
.BR \-h " or " \-?
.TP
.B \-\-help
Display brief usage information on
.IR stderr ,
and terminate immediately with a success status code.
.\"---------------------------------------------------------------------
.TP
.BI \-i " nnn"
.TP
.BI \-\-indent " nnn"
Set the number of spaces for each indentation level (default: 4).  The
value is forced into the nearest endpoint of the range 0 .\|.\|. 16 if
it is outside that interval.  Although a zero value is accepted, it
is not recommended, because suppressing indentation obscures the logical
structure.
.\"---------------------------------------------------------------------
.TP
.BI \-l " filename"
.TP
.BI \-\-logfile " filename"
Redirect warning and error messages from
.I stderr
to the indicated filename.  This option is provided for user
convenience on operating systems (e.g., IBM PC DOS) that fail to
provide for redirection of
.I stderr
to a specified file.
.IP
If the file cannot be opened for output,
.B texpretty
will terminate silently (because the internal attempted redirection
required the closure of
.IR stderr )
with a non-zero exit code.
.\"---------------------------------------------------------------------
.TP
.BI \-m " nnn"
.TP
.BI \-\-math-conversions " nnn"
Select the mathematics mode style conversion (default: 0 \(em no
conversion).  The value
.I nnn
is the sum of the desired numbers from this list (for each of the two
cases of inline and display mathematics, the largest number chosen is
the one that is used):
.RS
.na
.TP \w'32'u+3n
1
Inline mathematics is coded as \fC$ .\|.\|. $\fP.
.TP
2
Inline mathematics is coded as \fC\e( .\|.\|. \e)\fP (\*(La\&).
.TP
4
Inline mathematics is coded as \fC\ebegin{math} .\|.\|. \eend{math}\fP
(\*(La\&).
.TP
8
Display mathematics is coded as \fC$$ .\|.\|. $$\fP.
.TP
16
Display mathematics is coded as \fC\e[ .\|.\|. \e]\fP (\*(La\&).
.TP
32
Display mathematics is coded as \fC\ebegin{displaymath}
\&.\|.\|. \eend{displaymath}\fP (\*(La\&).
.ad
.RE
.IP
.B texpretty
recognizes all of these forms in the input stream.
.IP
This option may be helpful in assisting in the conversion between
\*(La\& and plain \*(Te\& markup, in standardizing the markup of
mathematics in \*(La\&, and in improving the possibilities for
detection of begin-end imbalances (when the dollar forms are
eliminated, and an editor or other software capable of delimiter
balance checking is employed).
.IP
Although the double-dollar markup style for display mathematics is
frequently found in \*(La\& documents, strictly speaking, it should
be replaced by either of the alternatives above.
.\"---------------------------------------------------------------------
.TP
.B \-n
.TP
.B \-\-no-comment-banner
Suppress generation of the default leading comment banner.
.\"---------------------------------------------------------------------
.TP
.BI \-o " filename"
.TP
.BI \-\-outfile " filename"
Redirect output from
.I stdout
to the indicated filename.  This option is provided for user
convenience on operating systems that fail to provide for convenient
redirection of
.I stdout
to a specified file.
.IP
If the file cannot be opened for output,
.B texpretty
will terminate with an error message and a non-zero exit code.
.\"---------------------------------------------------------------------
.TP
.B \-q
.TP
.B \-\-quick
Suppress reading of the two default style files (see the
.B "STYLE FILES"
section below).  Style files explicitly specified with the
.B \-s
options will still be processed.
.\"---------------------------------------------------------------------
.TP
.BI \-s " filename"
.TP
.BI \-\-stylefile " filename"
Name a style file (see the
.B "STYLE FILES"
section below) to augment
.BR texpretty 's
built-in knowledge of standard environments and control sequences.
.\"---------------------------------------------------------------------
.TP
.B \-t
.TP
.B \-\-tabular-as-verbatim
Copy tabular environments verbatim.  This is sometimes desirable if
they have already been carefully formatted.
.IP
Otherwise,
.B texpretty
carries out its normal prettyprinting activities inside tabular
environments, except that there, it lines up ampersand column
separators on line positions that are multiples of 8, to improve
vertical alignment for better readability.  This is about the best it
can do with only a single pass over the environment.
.\"---------------------------------------------------------------------
.TP
.B \-v
.TP
.B \-\-version
Show version information on
.IR stderr ,
and terminate immediately with a success status code.
.\"---------------------------------------------------------------------
.TP
.BI \-w " nnn"
.TP
.BI \-\-width " nnn"
Set the maximum output line width (default: 72).  This limit may be
exceeded if an excessively long string without embedded spaces is
encountered, and it is ignored completely inside comments and verbatim
text.  The line width value is forced into the nearest endpoint of the
range 16 .\|.\|. 1024 if it is outside that interval.
.\"=====================================================================
.SH "FORMATTING ACTIONS"
.B texpretty
carries out these major formatting actions (except in verbatim
environments, where all input text is preserved exactly):
.RS
.\"---------------------------------------------------------------------
.TP \w'\(bu'u+1n
\(bu
Long lines are wrapped to obey the requested (or default) maximum
output line width.
.\"---------------------------------------------------------------------
.TP
\(bu
Text inside \*(La\& \fC\ebegin .\|.\|. \eend\fP environments is
indented according to the environment nesting level, except for the
outer \fCdocument\fP environment, which does
.I not
cause indentation.
.\"---------------------------------------------------------------------
.TP
\(bu
Brace, bracket, environment, mathematics mode, and parenthesis balance
are checked for inconsistencies, except inside verbatim environments.
Apart from environments, none of these are expected to contain empty
lines signifying a paragraph break.
.IP
If multiple paragraphs really
.I are
intended between opening and closing delimiters, you can suppress the
warning messages by inserting \fC\epar\fP on the empty lines to ensure that
\*(Te\& sees the paragraph breaks, but
.B texpretty
does not.  However, remember that \*(Te\& forbids paragraph breaks
inside mathematics mode, so if you inserted blank lines there to
improve readability, just change them to empty comment lines.
.IP
For those rare cases where unmatched delimiters are intended, you
can eliminate the warning messages by hiding matching delimiters
inside comments in the same line or paragraph.
.\"---------------------------------------------------------------------
.TP
\(bu
Newlines are inserted before and/or after important control sequences
to improve their visibility.
.\"---------------------------------------------------------------------
.TP
\(bu
Comment percent characters are inserted after open braces at
end-of-line, to avoid unwanted space creeping into macro arguments.
.\"---------------------------------------------------------------------
.TP
\(bu
Ties before literature citations are removed; their use is a common
error.
.\"---------------------------------------------------------------------
.TP
\(bu
Redundant consecutive newlines are reduced to just two, indicating a
paragraph break.
.\"---------------------------------------------------------------------
.TP
\(bu
Whitespace (tabs, formfeeds, line breaks) other than literal space
(ISO 8859/ASCII decimal 32) is converted to literal space.
.\"---------------------------------------------------------------------
.TP
\(bu
Redundant consecutive spaces are reduced to just one, or two after
sentence-ending punctuation.
.\"---------------------------------------------------------------------
.TP
\(bu
End-of-line spaces are discarded.
.\"---------------------------------------------------------------------
.TP
\(bu
Spaces between certain control sequences and their arguments are
discarded.  These are cases where the arguments are generally short,
and should appear on the same line as the control sequence.
.\"---------------------------------------------------------------------
.TP
\(bu
Backslash-newline is converted to backslash-space-percent-newline.
The reason for this change is that automatic line wrapping and filling
in text editors can break a backslash-space control sequence at a line
boundary, which can potentially change the meaning of a document if
backslash-newline is defined differently than backslash-space.  Thus,
you should
.I not
use
.B texpretty
on files where these two control sequences have different meanings.
.\"---------------------------------------------------------------------
.TP
\(bu
Control sequences (footnotes, glossary, index, label, and
cross-reference) that must be tightly bound to the preceding word to
avoid the possibility of an intervening space, line break, or page
break, are output on a new line, with the preceding line ending with a
comment percent character.  \*(Te\& ignores text from the comment
character up to just before the first non-blank character on the next
line, so the control sequence is still tightly bound to the preceding
word, but is more readable.
.\"---------------------------------------------------------------------
.TP
\(bu
In tabular environments, additional whitespace is produced to line up
ampersand column separators at column positions that are multiples of 8,
except when the
.B \-t
command-line option has been specified to force verbatim output.
.RE
.PP
\*(Al\& and \*(La\& files that adhere to the markup defined in the
.I "\*(La\& User's Guide and Reference Manual"
by Leslie Lamport (Addison-Wesley, 1985 (ISBN 0-201-15790-X), 1994
(ISBN 0-201-52983-1)), and the
.I "\*(La\& Companion
by Michel Goossens, Frank Mittelbach, and Alexander Samarin
(Addison-Wesley, 1994 (0-201-54199-8)), will benefit most from
.BR texpretty 's
processing.
.\"=====================================================================
.SH "STYLE FILES"
In the current implementation of
.BR texpretty ,
all of the standard \*(Ax\&, \*(Al\&, \*(Ex\&, \*(Lm\&,
\*(La\&, and \*(Sx\& control words, environments, and comment
syntax that require special formatting are hard-coded into the
program.  However, users can define new control sequences and
environments with \*(Te\& \fC\edef\fP, \fC\eedef\fP, \fC\egdef\fP, and
\fC\exdef\fP commands, and with \*(La\& \fC\enewcommand\fP,
\fC\enewenvironment\fP, \fC\enewtheorem\fP, \&.\|.\|. commands.
.PP
In order to allow the user to control the formatting of these new
features,
.B texpretty
supports a simple style file mechanism.  At startup, it processes a
style file in the user's home directory, and another in the current
directory.  Neither of these need exist.  During command-line argument
processing, additional style files can be provided with the
.B \-s
option.  These style files support user-specific,
directory-specific, and file-specific prettyprinting control.
.PP
The default name of the first two style files is system dependent:
.I .texprettyrc
(UNIX),
.I texpty.ini
(IBM PC DOS), and
.I texpretty.ini
(DEC VMS and OpenVMS).
.PP
The line length limit in style files is system-dependent, but
guaranteed to be at least 1024 characters.
.PP
.B texpretty's
formatting actions group control sequences into the following
style classes:
.hy 0
.na
.\"---------------------------------------------------------------------
.TP \w`command-argument`u+3n
.B chapter
sectional division
.br
\*(Lm\&:
\fC\edocstyle \esubtopic \etopic\fP
.br
\*(La\&:
\fC\eappendix \ebackmatter \echapter \edocumentclass \edocumentstyle
\efrontmatter \emainmatter \eparagraph \epart \esection \esubparagraph
\esubsection \esubsubsection\fP
.br
plain \*(Te\&:
\fC\ebeginchapter \ebeginsection \eendchapter\fP
.\"---------------------------------------------------------------------
.TP
.B chapter-line
sectional division with argument all text to end of line
.br
\*(Ti\&:
\fC@chapter @section @subsection @subsubsection @unnumbered @unnumberedsec
@unnumberedsubsec @unnumberedsubsubsec\fP
.\"---------------------------------------------------------------------
.TP
.B cite
literature citation
.br
\*(Lm\& and \*(La\&:
\fC\ecite\fP
.br
\*(La\&:
\fC\enocite\fP
.br
\*(Ti\&:
\fC@cite\fP
.\"---------------------------------------------------------------------
.TP
.B command-argument
control sequence with its braced argument on same line
.br
\*(Ti\&:
\fC@code @emph @kbd @key @ref @samp @TeX @var @w @xref\fP
.\"---------------------------------------------------------------------
.TP
.B command-line
control sequence with argument all text to end of line
.br
\*(Ti\&:
\fC@auindex @cindex @defcodeindex @defindex @findex @kindex @pindex
@printindex @shorttitlepage @tindex @vindex\fP
.\"---------------------------------------------------------------------
.TP
.B comment
comment to end of line (any \*(Te\&)
.br
all but \*(Ti\&:
\fC%\fP
.br
\*(Ti\&:
\fC@c @comment\fP
.\"---------------------------------------------------------------------
.TP
.B default
.br
all but \*(Ti\&:
unrecognized backslash control sequences
.br
\*(Ti\&:
\fC@ETC @b @bullet @copyright @dfn @dmn @dots @enddots @equiv
@expansion @file @headword @i @math @minus @occur @par @point @print
@pxref @r @refill @regularbooksize @result @sc @strong @t @thischapter
@thischaptername @thisfile @thispage @thistitle @titlefont @today
@value\fP
.\"---------------------------------------------------------------------
.TP
.B displaymath
displayed mathematics
.br
any \*(Te\&:
\fC$$\fP
.br
\*(La\&:
\fC\ebegin{displaymath} \eend{displaymath} \e[ \e]\fP
.\"---------------------------------------------------------------------
.TP
.B environment
text group with specialized formatting
.br
\*(Ax\&:
\fC\eCD \eendCD \eRefs \eendRefs \eSb \eendSb \eSp \eendSp \eVmatrix
\eendVmatrix \eabstract \eendabstract \eaffil \eendaffil \ealign
\eendalign \ealignat \eendalignat \ealigned \eendaligned \ealignedat
\eendalignedat \eblock \eendblock \ebmatrix \eendbmatrix \ecases
\eendcases \ecfrac \eendcfrac \ecomment \eendcomment \ecurraddr
\eendcurraddr \ededicatory \eenddedicatory \edefinition
\eenddefinition \edemo \eenddemo \edocument \eenddocument \eemail
\eendemail \eexample \eendexample \egather \eendgather \egathered
\eendgathered \egraf \eendgraf \ehead \eendhead \ekeywords
\eendkeywords \ematrix \eendmatrix \emultline \eendmultline \epmatrix
\eendpmatrix \eproclaim \eendproclaim \eremark \eendremark
\esmallmatrix \eendsmallmatrix \especialhead \eendspecialhead \esplit
\eendsplit \esubhead \eendsubhead \esubjclass \eendsubjclass
\esubsubhead \eendsubsubhead \etoc \eendtoc \etopmatter \eendtopmatter
\etranslator \eendtranslator \evmatrix \eendvmatrix \exalignat
\eendxalignat \exxalignat \eendxxalignat\fP
.br
\*(Lm\&:
\fC\eFigure \eendFigure \eFigurepair \eendFigurepair \eFiguretriple
\eendFiguretriple \eHL \eendHL \eTable \eendTable \ebdmatrix
\eendbdmatrix \eclaim \eendclaim \eheading \eendheading \eisland
\eendisland \emakebib \eendmakebib \epartition \eendpartition\fP
.br
\*(La\& (with exceptions given in other classes):
\fC\ebegin{\fIenvname\fP} \eend{\fIenvname\fP}\fP
.br
plain \*(Te\&:
\fC\ebegingroup \eendgroup \ebgroup \eegroup\fP
.br
\*(Ti\&:
\fC@cartouche @display @end @flushleft @flushright @format @group
@ifinfo @iftex @quotation @smallexample @smalllisp @titlepage\fP
.\"---------------------------------------------------------------------
.TP
.B footnote
comment and newline before
.br
\*(Ex\&:
\fC\enumberedfootnote\fP
.br
\*(Lm\&:
\fC\eplainfootnote \eplainproclaim\fP
.br
\*(La\&:
\fC\efootnote \efootnotetext \elabel \epageref \eref\fP
.br
plain \*(Te\&:
\fC\evfootnote\fP
.br
\*(Ti\&:
\fC@footnote\fP
.\"---------------------------------------------------------------------
.TP
.B index
index and glossary
.br
\*(Ex\&:
\fC\eidx \eidxmarked \eidxname \eidxsubmarked \esidx \esidxmarked
\esidxname \esidxsubmarked\fP
.br
\*(La\&:
\fC\eglossary \eindex\fP
.\"---------------------------------------------------------------------
.TP
.B list
list of items
.br
\*(Ax\&:
\fC\eroster \eendroster\fP
.br
\*(Ex\&:
\fC\enumberedlist \eendnumberedlist \eorderedlist \eendorderedlist
\eunorderedlist \eendunorderedlist\fP
.br
\*(Lm\&:
\fC\ebib \eendbib \ebullist \eendbullist \edescribe \eenddescribe
\elist \eendlist \emargins \eendmargins\fP
.br
\*(La\&:
\fC\ebegin{description} \eend{description} \ebegin{enumerate}
\eend{enumerate} \ebegin{itemize} \eend{itemize} \ebegin{list}
\eend{list} \ebegin{thebibliography} \eend{thebibliography}
\ebegin{trivlist} \eend{trivlist}\fP
.br
\*(Ti\&:
\fC@enumerate @ftable @itemize @table @vtable\fP
.\"---------------------------------------------------------------------
.TP
.B list-item
item in a list
.br
\*(Ax\&:
\fC\eruninitem\fP
.br
\*(La\&:
\fC\ebibitem \eitem\fP
.br
plain \*(Te\&:
\fC\eitemitem\fP
.br
\*(Ti\&:
\fC@item @itemx\fP
.\"---------------------------------------------------------------------
.TP
.B math
inline mathematics
.br
any \*(Te\&:
\fC$\fP
.br
\*(La\&:
\fC\ebegin{math} \eend{math} \e( \e)\fP
.\"---------------------------------------------------------------------
.TP
.B newline-after
newline after control sequence
.br
\*(La\&:
\fC\e\e \e\e* \ekill\fP
.br
plain \*(Te\&:
\fC\ecr \ecrcr \eendline\fP
.br
\*(Ti\&:
\fC@*\fP
.\"---------------------------------------------------------------------
.TP
.B newline-before
newline before control sequence
.br
\*(Al\&:
\fC\eDeclareMathOperator \eDeclareMathSymbol \eDeclareSymbolFont
\enumberwithin \eswapnumbers \enewtheoremstyle \etheoremstyle\fP
.br
\*(Ax\&:
\fC\eadjustfootnotemark \ebook \ebookinfo \ebookinquotes \ebotcaption
\eby \ebysame \ecaptionwidth \edefine \eed \eeds \efinalinfo \einbook
\eissue \ejour \elang \emoreref \enewsymbol \eno \enoquotes \epage
\epages \epaper \epaperinfo \epaperinquotes \eparshape \epreaffil
\epreauthor \epredate \epredefine \eprepaper \epretitle \epubl
\epubladdr \eredefine \eshoveleft \eshoveright \etoappear \etopcaption
\etransl \eundefine \evol \ewidestnumber \eyr\fP
.br
\*(Ex\&:
\fC\edefineindex \edefinecontentsfile \ecenter
\ecolumnfill \edoublecolumns \eedefappend \eflushleft \eflushright
\efor \eiffileexists \einnerdef \einnerinnerdef \einnernewbox
\einnernewcount \einnernewdimen \einnernewfam \einnernewhelp
\einnernewif \einnernewinsert \einnernewmuskip \einnernewread
\einnernewskip \einnernewtoks \einnernewwrite \elisting
\emakecolumns \equadcolumns \ereadindexfile \ereadtocfile
\etestfileexistence \etocchapterentry \etocsectionentry
\etriplecolumns \ewritenumberedtocentry \ewritetocentry\fP
.br
\*(Lm\&:
\fC\eCgaps \eEntry \eEntryxref \eLETTER \eMorexref \eNoexpand
\eNonexpanding \eOffset \ePage \ePageSpan \ePagespan \ePostCDSpace
\ePreCDSpace \eReset \eRgaps \eTopage \eXref \ecgaps \ecleartable
\ecounter \eeverytable \eex \eexs \eflushpar \efnote \efoottext \ehL
\ehdashed \ehl \ehls \ehtablelines \eiabbrev \eidefine \elitbackslash
\elitdelimiter \emainfile \emakepiece \emanyby \emeasuretable
\emodifyfootnote \enameHL \enamehl \enewHL \enewclaim \enewfontstyle
\enewhl \enewisland \enewnumstyle \enewpost \enewpre \enewstyle
\enewword \enote \epageorder \epostCDspace \epostdocstyle \epreCDspace
\epredocstyle \epullin \epullinmore \epurge \ereadaux \ergaps
\erunningchapter \erunningsection \eshortenclaim \eshowstored \esss
\estoretable \etablewidth \etbldocstyle \etdefine \etoclevel
\etredefine \etss \eunpurge \eusetable \evleft \evright \evs \evsolid
\evtablelines\fP
.br
\*(Lm\& and \*(La\&:
\fC\eauthor \edate \ethanks \etitle\fP
.br
\*(La\&:
\fC\eaddress \ecaption \eclosing \eglossaryentry \einclude
\eincludeonly \eindexentry \emakeglossary \emakeindex \emarginpar
\emarkboth \emarkright \emultiput \enewblock \enewboolean \enewcommand
\enewcounter \enewenvironment \enewlength \enewsavebox \enewtheorem
\eopening \eprintindex \eprovidecommand \eput \erenewcommand
\erenewenvironment \esignature \etypein \etypeout \eusepackage
\evspace\fP
.br
plain \*(Te\&:
\fC\ecenterline \echardef \eclosein \ecloseout \ecountdef \edef
\edimendef \eedef \eelse \eendinput \eeqalign \eeqalignno \eerrmessage
\efi \efuturelet \efuturenonspacelet \egdef \eglobal \ehalign \ehang
\ehoffset \ehyphenation \eialign \eif \eifcase \eifcat \eifdim \eifeof
\eiffalse \eifhbox \eifhmode \eifinner \eifmmode \eifnum \eifodd
\eiftrue \eifundefined \eifvbox \eifvmode \eifvoid \eifx \eimmediate
\einput \eleftline \eleqalignno \elet \eline \elisting \eloop
\emagnifiction \emark \emathchardef \emessage \enarrower \enewbox
\enewcount \enewdimen \enewfam \enewhelp \enewif \enewinsert
\enewmuskip \enewread \enewskip \enewtoks \enewwrite \enoalign
\eopenin \eopenout \eparindent \eread \erepeat \erightline \eshow
\eshowbox \eshowboxbreadth \eshowdepth \eshowhyphens \eshowlists
\eshowthe \eskipdef \especial \etabalign \etextindent \etoksdef
\etracingall \etracingcommands \etracinglostchars \etracingmacros
\etracingonline \etracingoutput \etracingpages \etracingparagraphs
\etracingrestores \etracingstats \evadjust \evalign \evoffset \evskip
\ewrite \exdef\fP
.br
\*(Ti\&:
\fC@appendix @appendixsec @appendixsection @appendixsubsec
@appendixsubsubsec @asis @inforef @setfilename @vskip\fP
.\"---------------------------------------------------------------------
.TP
.B standalone
control sequence isolated on its own line
.br
\*(Al\&:
\fC\eallowdisplaybreaks \edisplaybreak\fP
.br
\*(Ax\&:
\fC\eBlackBoxes \eCenteredTagsOnSplits \eChangeBuffer \eLimitsOnInts
\eLimitsOnNames \eLimitsOnSums \eMonograph \eMultLineGap
\eNoBlackBoxes \eNoPageNumbers \eNoRunningHeads \eResetBuffer
\eRuninitem \eTagsAsMath \eTagsAsText \eTagsOnLeft \eTagsOnRight
\eTopOrBottomTagsOnSplits \eUseAMSsymbols \eUseBibTeX \ecaptionwidth
\eendinsert \efoldedpar \egalleys \ehcorrection \eininbook \eloadbold
\eloadeufb \eloadeufm \eloadeurb \eloadeurm \eloadeusb \eloadeusm
\eloadmsam \eloadmsbm \emidinsert \emultlinegap \eoperatorname
\epageheight \epageinsert \epagewidth \eprintoptions \eshowallocations
\espreadlines \espreadmatrixlines \esyntax \etopinsert \evcorrection\fP
.br
\*(Lm\&:
\fC\eFigureproofing \eFlushedFigs \eInitialize \eNS \eNoFlushedFigs
\eRefWarnings \ealldq \eboxedtables \ecolumnbreak \econtinuelist
\efigureproofing \eindexfile \eindexproofing \einlevel \ekeepitem
\emakelistFigures \emakelistTables \emakelistfigures \emakelisttables
\emaketoc \enewcolumn \enoFigureproofing \enocolumnbreak
\enofigureproofing \enoshowsecondpass \eopentables \eoutlevel
\eshortlastcolumn \eshowcolwidths \eshowsecondpass \esides
\essizeCDlabels \etocfile \etsizeCDlabels\fP
.br
\*(Lm\& and \*(La\&:
\fC\ebibliography \ebibliographystyle\fP
.br
\*(La\&:
\fC\ebigpagebreak \ecleardoublepage \eclearpage \edefinecolor
\eenlargethispage \eflushbottom \efussy \ehline \eindexspace
\elinebreak \elistfiles \elistoffigures \elistoftables \emaketitle
\emedpagebreak \enewline \enewpage \enofiles \enolinebreak
\enopagebreak \enopagenumbers \enormalbottom \enormalmarginpar
\eonecolumn \eonlynotes \eonlyslides \epagebreak \epagecolor
\epagenumbering \epagestyle \eraggedleft \ereversemarginpar \esloppy
\esmallpagebreak \esuppressfloats \etableofcontents \ethispagestyle
\etwocolumn\fP
.br
plain \*(Te\&:
\fC\eallowbreak \eannotations \ebatchmode \ebigbreak \ebigskip \ebody
\ebreak \ebye \ecentering \edosupereject \eeject \eendletter
\eerrorstopmode \efilbreak \efrenchspacing \egoodbreak \eindent
\eleavevmode \emakelabel \emedbreak \emedskip \enoindent
\enonfrenchspacing \enonstopmode \epar \eraggedbottom \eraggedcenter
\eraggedright \eremovelastskip \escrollmode \esmallbreak \esmallskip
\ettraggedright \evfil \evfilneg \evfill\fP
.br
\*(Ti\&:
\fC@afourpaper @bye @contents @cropmarks @finalout @lowersections
@noindent @page @raisesections @shortcontents @smallbook
@summarycontents\fP
.\"---------------------------------------------------------------------
.TP
.B tabular
tabular text
.br
\*(La\&:
\fC\ebegin{tabular} \eend{tabular} \ebegin{tabular*} \eend{tabular*}\fP
.\"---------------------------------------------------------------------
.TP
.B verb
inline verbatim
.br
\*(Ex\&:
\fC\everbatim\fP (may contain line breaks, and doubled delimiters
representing a single character)
.br
\*(Lm\&:
\fC\eLit \elit\fP (\fC\eLit\fP can contain line breaks, but its syntax
is that of \fC\elit\fP)
.br
\*(La\&:
\fC\everb \everb*\fP
.br
any \*(Te\&:
\fC\epath\fP
.\"---------------------------------------------------------------------
.TP
.B verbatim
multiline verbatim environment
.br
\*(La\&:
\fC\ebegin{verbatim} \eend{verbatim} \ebegin{verbatim*} \eend{verbatim*}\fP
.br
\*(Ti\&:
\fC@defcv @deffn @defivar @defmac @defmethod @defop @defopt @defspec
@deftp @deftypefn @deftypefun @deftypefunx @deftypevar @deftypevr
@defun @defunx @defvar @defvr @example @ignore @lisp @menu @tex\fP
.\"---------------------------------------------------------------------
.ad
.hy 1
.PP
The style class
.B default
can be used to force a command or environment to revert to the
default formatting rules: no special indentation for commands, and
normal indentation for environments.  You can use this to override
earlier style file settings, and most of the built-in ones.
.PP
Style class names, like \*(Te\& control sequences and \*(La\&
environments, are
.IR "case sensitive" .
All of the ones recognized by
.B texpretty
must be spelled with lowercase letters.
.PP
The style file is expected to contain lines of the form:
.RS
.nf
\fCstyle-class : envname1 envname2 .\|.\|. \ecommand1 \ecommand2 .\|.\|.\fP
.fi
.RE
Blank lines, leading and trailing whitespace, and text from the
\*(Te\& comment character (%) to end of line, are ignored.
Whitespace separates items, and can be omitted around the colon.
There is no significance to the order of items on a line, or lines in
the file, except that later settings can override earlier ones.
The same style class name may occur on multiple lines.
.PP
For example, suppose you have defined new sectional division commands
named \fC\eKapitel\fP and \fC\eTeil\fP, a new tabular environment named
\fC\eSuperTabular\fP, and two new display math environments named
\fCEasyMath\fP and \fCHardMath\fP.  Your style file might then look
something like this:
.RS
.nf
\fC% additional texpretty style specifications\fP
\fC% [02-Jun-1995]\fP
\fCchapter :       \eKapitel \eTeil\fP
\fCtabular :       SuperTabular\fP
\fCdisplaymath :   EasyMath HardMath\fP
.fi
.RE
.PP
\*(Li\& is, sadly, less widely used than \*(Ti\&; it supports
most of the standard \*(La\& commands, plus a few others: some
additional sectioning and indexing commands, two comment-start macros
(\fC\ec\fP and \fC\ecomment\fP), a hypertext link macro (\fC\enode\fP)
and a \fCmenu\fP environment in which line breaks are significant.
Here is a suitable
.B texpretty
style file for \*(Li\& files (there are additional \*(Li\&
control sequences not listed here, but they do not require any
particular special formatting):
.RS
.nf
\fC% LaTeXinfo style file for texpretty
% [08-Jun-1995]
chapter        : \eunnumbered \eunnumberedsec \eunnumberedsubsec
chapter        : \eunnumberedsubsubsec
comment        : \ec \ecomment \enode
index          : \ecindex \ecpindexbold \ecpsubindex \efindex
index          : \ekindex \epindex \etindex \evindex
newline-after  : \e* \ebr
newline-before : \ecopyright \enewindex \esetfilename \esynindex
verbatim       : ifinfo ignore menu\fP
.fi
.RE
The \fC\enode\fP macro can be handled by the \fBcomment\fP class
because all of its arguments follow on the same line, up to the end of
the line.  Menu environments are usually laid out neatly, because
their formatting is preserved exactly in the ASCII output used for
online info documentation; prettyprinting them in verbatim mode
ensures that the layout will be retained.  The \fC\e*\fP macro will
actually not be recognized in the current version of
.BR texpretty ,
because macro names definable in style files may contain only letters
after the leading backslash.  In this case, no harm will arise, since
the default formatting of control sequences containing special
characters is adequate.
.PP
There is no built-in support in
.B texpretty
for \*(Li\&, because it has not achieved widespread use; however,
the style file above should be sufficient for
.B texpretty
to prettyprint \*(Li\& files correctly.
.PP
The last style class attached to command or environment name is
the one that is used, so specifications in a command-line style
file can override those in the current directory style file, and
those in turn override settings from the home directory style file.
.PP
The
.B \-d
and
.B \-t
command-line options affect the prettyprinting of all commands in
the
.B math
and
.B tabular
classes.
.PP
Don't use the
.B \-m
math mode translation option if you specify the
.B math
class in a style file; if you do, those commands and environments will
be renamed.  When math mode translation is selected, it may also be
advisable to specify the
.B \-q
option, and avoid
.B \-s
options, to eliminate all style file input.
.PP
For the purposes of matching \*(Te\& control words,
.B texpretty
assumes that they begin with a backslash followed by one or more letters
or at-sign; the latter is commonly used inside macro packages to create
command names that are supposed to be hidden from the end user.  There
is no provision in style files for modifying this assumption.
.PP
Occasionally, it may be desirable to have a control sequence and its
arguments handled together as an indivisible unit. To support this,
control sequences in style files may be followed by zero or more of
the following patterns, in whatever order is required:
.RS
.TP \w`\fC{}\fP`u+2n
\fC*\fP
Match an optional literal asterisk; \*(La\& uses this for variant forms.
.TP
\fC[]\fP
Match an optional argument in balanced brackets (\*(La\&).
.TP
\fC""\fP
Match an optional argument in quotes (\*(Ax\& and \*(Lm\&).
.TP
\fC()\fP
Match a required argument in balanced parentheses (\*(La\&).
.TP
\fC{}\fP
Match a required argument in balanced braces (any \*(Te\&).
.TP
\fC\e\fP
Match an alphabetic control sequence (\*(Lm\&).
.RE
These patterns are ignored for
.BR index ,
.BR verb ,
and
.B verbatim
style classes, because they have their own specialized formatting
requirements.
.PP
Here is a sample style file that illustrates the use of argument
patterns:
.RS
.nf
\fCdefault        : \emakebox()[]{} % \*(La\&
list-item      : \eitem""        % \*(Ax\& and \*(Lm\&
standalone     : \eReset\e        % \*(Lm\&: e.g., \eReset \elist\fP
.fi
.RE
When argument patterns are processed, whitespace before and between
arguments in the input stream is discarded as long as an argument
match is found.  Arguments themselves are copied verbatim, even if
they include line breaks or comments.  The only requirement is that
braced, bracketed, or parenthesized arguments have balanced delimiters.
.PP
Control sequence name matching against style file specifications does
not include any argument patterns, so if the same control sequence
name is specified more than once in a style file, as in
.RS
.nf
\fClist-item      : \emyitem"" \emyitem() \emyitem[] \emyitem{}\fP
.fi
.RE
only the last one will be effective, in this case, a required braced
argument.  This should not normally be a serious limitation, because
\*(Te\& control sequence definitions that include argument delimiter
characters also have this behavior.  However, it
.I is
possible with special programming to use one-character lookahead to
distinguish between argument types, and \*(La\& does this internally
for optional bracketed arguments, and asterisked variants.
.\"=====================================================================
.SH LIMITATIONS
A fundamental assumption of any prettyprinter is that whitespace
(blank, horizontal tab, vertical tab, carriage return, formfeed,
newline) is
.I not
significant.  While this is generally the case, it is not so in those
rare \*(Te\& files where whitespace is made active by \fC\ecatcode\fP
modification.  Avoid using
.B texpretty
on such files, or on files where the comment character is something
other than the normal percent character.  There is no problem with
\*(La\& verbatim macros and environments, because
.B texpretty
recognizes them and preserves their contents exactly.
.PP
User-defined control sequences for which whitespace is significant, or
whose use is idiosyncratically formatted, will likely conflict with
prettyprinting.
.PP
The plain \*(Te\& \fC\eobeylines\fP and \fC\eobeyspaces\fP commands,
and the \*(Ex\& \fC\eobeywhitespace\fP command, would be similarly
mishandled, except that
.B texpretty
watches for them, and once they are seen, copies the remainder of the
file in verbatim mode, effectively suppressing further prettyprinting.
It has to do this, because it has no reliable way to detect the end of
scope for these commands.
.PP
For a small number of control sequences, there are formatting
conflicts between two or more macro packages.  In such a case,
preference is first given to \*(La\& (and \*(Al\& and \*(Sx\&),
then to \*(Ax\&, then to \*(Lm\&, and finally to plain \*(Te\&
and \*(Ex\&.
.PP
There are also cases in some of these macro packages where the same
control sequence has environment-dependent meaning, so formatting
irregularities may appear.
.\"=====================================================================
.SH "SEE ALSO"
.BR amstex (1),
.BR amslatex (1),
.BR chkdelim (1),
.BR etex (1)
(or visit Emacs info node
.BR eplain ),
.BR lacheck (1),
.BR lamstex (1),
.BR latex (1),
.BR latexinfo (1)
(or visit Emacs info node
.BR latexinfo ),
.BR scribe (1),
.BR tex (1),
.BR texinfo (1)
(or visit Emacs info node
.BR texinfo ).
.\"=====================================================================
.SH AUTHOR
.nf
Nelson H. F. Beebe
Center for Scientific Computing
University of Utah
Department of Mathematics, 322 INSCC
155 S 1400 E RM 233
Salt Lake City, UT 84112-0090
USA
Email: \fCbeebe@math.utah.edu\fP, \fCbeebe@acm.org\fP,
.if n .ti +\w'Email:\ 'u
.if t .ti +\w'Email:\ 'u
\fCbeebe@computer.org\fP, \fCbeebe@ieee.org\fP (Internet)
WWW URL: \fChttp://www.math.utah.edu/~beebe\fP
Telephone: +1 801 581 5254
FAX: +1 801 585 1640, +1 801 581 4148
.fi
.\"=====================================================================
.SH AVAILABILITY
.B texpretty
is freely available, and is licensed under the Free Software
Foundation's GNU Public License (GPL), included in the file
.I COPYING
in the distribution.
.PP
.BR texpretty 's
master distribution can be found at
.PP
.RS
.nf
\&\fCftp://ftp.math.utah.edu/pub/misc/\fP
\&\fChttp://www.math.utah.edu/pub/misc/\fP
.fi
.RE
.PP
in the file
.I texpretty-x.yz.tar.gz
where
.I x.yz
is the current version.  Additional distribution formats are usually
available at the same location.
.PP
That site is mirrored to several other Internet archives, so you may
also be able to find it elsewhere on the Internet; try searching for
the string
.I texpretty
at one or more of the popular Web search sites, such as
.PP
.RS
.nf
\&\fChttp://altavista.digital.com/
http://search.microsoft.com/us/default.asp
http://www.dejanews.com/
http://www.dogpile.com/index.html
http://www.euroseek.net/page?ifl=uk
http://www.excite.com/
http://www.go2net.com/search.html
http://www.google.com/
http://www.hotbot.com/
http://www.infoseek.com/
http://www.inktomi.com/
http://www.lycos.com/
http://www.northernlight.com/
http://www.snap.com/
http://www.stpt.com/
http://www.yahoo.com/\fP
.fi
.RE
.\"==============================[The End]==============================
